#define IP_HDRLEN_MASK				((BYTE) 0x0f)

#define TCP_FLAG_URGENT				0x20
#define TCP_FLAG_ACK				0x10
#define TCP_FLAG_PUSH				0x08
#define TCP_FLAG_RESET				0x04
#define TCP_FLAG_SYN				0x02
#define TCP_FLAG_FIN				0x01

#define ECHO_REPLY					0
#define DESTINATION_UNREACHABLE		3
#define SOURCE_QUENCH				4
#define REDIRECT					5
#define ECHO						8
#define ROUTER_ADVERTISEMENT		9
#define ROUTER_SOLICITATION			10
#define TIME_EXCEEDED				11
#define PARAMETER_PROBLEM			12
#define TIMESTAMP					13
#define TIMESTAMP_REPLY				14
#define INFORMATION_REQUEST			15
#define INFORMATION_REPLY			16
#define ADDRESS_MASK_REQUEST		17
#define ADDRESS_MASK_REPLY			18

typedef struct
{
    unsigned char  ip_verlen ;
    unsigned char  ip_tos ;
    unsigned short ip_totallength ;
    unsigned short ip_id ;
    unsigned short ip_offset ;
    unsigned char  ip_ttl ;
    unsigned char  ip_protocol ;
    unsigned short ip_checksum ;
    unsigned int   ip_srcaddr ;
    unsigned int   ip_destaddr ;

} IP ;

typedef struct 
{
   unsigned char	Type ;
   unsigned char	Code ;
   unsigned short	Checksum ;
   unsigned long	Misc ;

} ICMP ;

typedef struct 
{
    unsigned short	SrcPort ;
    unsigned short	DstPort ;
    unsigned long	SeqNum ;
    unsigned long	AckNum ;
    unsigned char	DataOff ;
    unsigned char	Flags ;
    unsigned short	Window ;
    unsigned short	Chksum ;
    unsigned short	UrgPtr ;

} TCP ;

typedef struct
{
	unsigned short	SrcPort ;
	unsigned short	DstPort ;
	unsigned short	DataOff ;
	unsigned short	Checksum ;

} UDP ;
